︠1fc425a5-a181-498c-87f2-397e204ec06fs︠
# 8
# define a function sum_digits(n) that takes an integer and returns the sum of its digits

def sum_digits(n):
    sum = 0
    while (n != 0):
        sum = sum + int(n % 10)
        n = int(n/10)
    return sum
︡9d4acd1a-c3b8-4464-aab8-d70957024df8︡{"done":true}
︠986816ea-6ff4-45b8-86d9-b8452451493as︠
sum_digits(18)
︡14e19a84-ddf8-401b-b63a-0cbcfd563d62︡{"stdout":"9\n"}︡{"done":true}
︠53827c50-c3e1-479f-9d93-8905d5da5ab6s︠
sum_digits(98)
︡6ba932f7-301d-4fdf-ab1b-395a93af41dc︡{"stdout":"17\n"}︡{"done":true}
︠ca1518fe-884d-4e3e-906e-1f076acff754s︠


# 9
# write a program to find all triples with positive integers a, b, c <= 10 where a^2 + b^2 = c^2

for a in [1..100]:
    for b in [1..100]:
        c2 = a**2 + b**2
        c = sqrt(c2)
        if int(c + 0.5) ** 2 == c2 and c <= 10:
            print "{}, {}, {}".format(a, b, c)
︡4206cf45-b7ee-4017-afb8-4b7bd8cde59b︡{"stdout":"3, 4, 5\n4, 3, 5\n6, 8, 10"}︡{"stdout":"\n8, 6, 10\n"}︡{"done":true}
︠4311819b-3372-464f-a978-914ff70013eas︠


# 10
# define a function a_count(s) that takes a string and counts the number of occurrences of the letter "a" in the string

def a_count(s):
    s = list(s) # turn string into list of characters
    acount = 0
    for char in s:
        if char == "a":
            acount = acount + 1
    return acount
︡2d0bc9ae-1ac5-4220-b420-93db6f1314a3︡{"done":true}
︠1dd45534-d8af-4a9e-8ad0-aa942cae9167s︠
a_count("aaaaa")
︡98f61385-f6e1-4072-baac-92683aa45300︡{"stdout":"5\n"}︡{"done":true}
︠c46fc6e4-3618-4ea1-9b7a-84449d39005fs︠
a_count("b")
︡60e3addf-e5b3-4d0b-8907-955a832886c3︡{"stdout":"0\n"}︡{"done":true}
︠fcef6432-9242-45cf-a7ba-e39768a7258cs︠


# # 11
# write a program that produces 100 random numbers from [0, 100] and stores them in separate lines of a text file

datafile = open("rand_store.txt", "w") # create a file and tell sage we are writing
for i in [1..100]: # loop through the WRITE command 100 times
    datafile.write(str(randint(0, 100))) # tell sage what we want to write into the file. remember to turn randint into string
    datafile.write("\n") # print each on a new line
datafile.close() # close the file once we have written the 100 lines
︡bb040a60-f0d7-4421-b546-dff80a4742d9︡{"done":true}
︠aae79dca-95d1-4056-9d49-d41dcf0ae0d8s︠


# 12
# define a function read_data(filename) that opens the file called filename and prints a list of the numbers in the file
def read_data(filename):
    filename = open("rand_store.txt", "r") # open the file and tell sage we we are doing. we are reading, so "r"
    numlist = []
    for i in [0..99]:
        dline = filename.readline()
        dline = int(dline.rstrip())
        numlist.append(dline)
    print numlist
︡6bcc347b-945a-4fd5-8ee2-ffab72f15e7a︡{"done":true}
︠aaf2dc04-51e1-4d3a-ab08-ac77ba7611bes︠
read_data(datafile)
︡64ed716b-b654-41b5-97c5-68cc7c6a7dff︡{"stdout":"[68, 77, 70, 40, 90, 27, 79, 37, 99, 98, 1, 78, 82, 24, 16, 66, 55, 0, 17, 47, 44, 98, 73, 73, 21, 36, 64, 10, 67, 46, 4, 35, 19, 29, 14, 94, 0, 30, 62, 100, 41, 27, 59, 35, 28, 4, 82, 8, 86, 58, 3, 54, 50, 100, 79, 27, 68, 95, 62, 38, 46, 39, 2, 83, 19, 10, 4, 41, 87, 98, 11, 82, 30, 57, 89, 15, 46, 69, 26, 68, 44, 65, 78, 19, 70, 84, 66, 81, 57, 30, 38, 22, 28, 34, 23, 81, 16, 62, 79, 76]\n"}︡{"done":true}
︠adb21da4-3e87-4ce6-a076-e1d789ebccads︠


# 13
# use map and an anonymous (lambda) function to produce cubes of the numbers in the list [3, 7, 2, 5]

testlist = [3, 7, 2, 5]
map(lambda x: x**3, testlist)
︡2eebcd83-b9b7-4d7a-a337-2b7662ac8386︡{"stdout":"[27, 343, 8, 125]\n"}︡{"done":true}
︠56c0d1ab-27f5-4a41-b5c4-30b4fa6cebdds︠


# 14
# consider the following sequence defined by a function on the positive integers t(1) = 3, t(2) = 4,
# t(3) = 5, t(n) = t(n - 1) + t(n - 2) + t(n - 3)
# define a recursive function recurst(n) that takes a positive integer n and outputs t(n). find t(10)

def recurst(n):
    if n == 1:
        return 3
    elif n == 2:
        return 4
    elif n == 3:
        return 5
    elif n > 3:
        tn = recurst(n - 1) + recurst(n - 2) + recurst(n - 3)
        return tn
︡4156b6b1-78f4-4879-81b9-fa600148ba62︡{"done":true}
︠6b6563f3-f349-40b8-96d8-cd8555be6e4as︠
recurst(10)
︡0c71ffd0-b01d-427f-8c93-20c37b933314︡{"stdout":"440\n"}︡{"done":true}
︠0df7d667-f726-4943-8b44-89c41589210cs︠
︡3aaf91e8-b5ff-4f4d-8294-66f5c9e4beda︡{"done":true}
︠0e9bb286-248b-4052-aac2-90498bcc55dds︠

︡79d6b549-7a68-49b1-955e-928e0680b626︡{"done":true}









